(* tools for differentiation
   WN.11.99
   use"../knowledge/Diff.ML";
   use"IsacKnowledge/Diff.ML";
   use"Diff.ML";
 *)


(** interface isabelle -- isac **)

theory' := overwritel (!theory', [("Diff.thy",Diff.thy)]);

(** problem types **)

store_pbt
 (prep_pbt Diff.thy "pbl_fun" [] e_pblID
 (["function"],
  [("#Given" ,["functionTerm f_","differentiateFor v_"]),
   ("#Find"  ,["derivative f_'_"])
  ],
  append_rls "e_rls" e_rls [], None, []));

store_pbt
 (prep_pbt Diff.thy "pbl_fun_deriv" [] e_pblID
 (["derivative_of","function"],
  [("#Given" ,["functionTerm f_","differentiateFor v_"]),
   ("#Find"  ,["derivative f_'_"])
  ],
  append_rls "e_rls" e_rls [], None, []));


(** methods **)

store_met
 (prep_met Diff.thy "met_diff" [] e_metID
 (["Diff"],
   [],
   {rew_ord'="tless_true",rls'=Atools_erls,calc = [], srls = e_rls, prls=e_rls,
    crls = Atools_erls, nrls=norm_Rational}, "empty_script"));

store_met
 (prep_met Diff.thy "met_diff_onR" [] e_metID
 (["Diff","differentiate_on_R"],
   [("#Given" ,["functionTerm f_","differentiateFor v_"]),
    ("#Find"  ,["derivative f_'_"])
    ],
   {rew_ord'="tless_true",rls'=Atools_erls,calc = [], srls = e_rls, prls=e_rls,
    crls=Atools_erls, nrls = e_rls
(*,  asm_rls=[],asm_thm=[("diff_quot","")]*)},
 "Script Differentiate (f_::real) (v_::real) =                \
 \((Try (Repeat (Rewrite frac_conv   False))) @@       \
 \ (Try (Repeat (Rewrite root_conv   False))) @@       \
 \ (Try (Repeat (Rewrite realpow_pow False))) @@      \
 \ (Repeat                                           \
 \   ((Repeat (Rewrite_Inst [(bdv,v_)] diff_sum        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_prod_const False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_prod       False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_quot       True )) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sin        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sin_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_cos        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_cos_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_pow        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_pow_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_ln         False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_ln_chain   False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_exp        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_exp_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sqrt       False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sqrt_chain False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_const      False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_var        False)) Or \
 \    (Repeat (Rewrite_Set             make_polynomial False)))) @@ \
 \ (Try (Repeat (Rewrite sym_frac_conv False))) @@              \
 \ (Try (Repeat (Rewrite sym_root_conv False)))) (f_::real)"
 ));

store_met
 (prep_met Diff.thy "met_diff_simpl" [] e_metID
 (["Diff","diff_simpl"],
   [("#Given" ,["functionTerm f_","differentiateFor v_"]),
    ("#Find"  ,["derivative f_'_"])
    ],
   {rew_ord'="tless_true",rls'=Atools_erls, calc = [], srls = e_rls,prls=e_rls,
    crls=Atools_erls, nrls=norm_Rational
    (*, asm_rls=[],asm_thm=[("diff_quot","")]*)},
 "Script Differentiate (f_::real) (v_::real) =                \
 \(Repeat                                           \
 \   ((Repeat (Rewrite_Inst [(bdv,v_)] diff_sum        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_prod_const False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_prod       False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_quot       True )) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sin        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sin_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_cos        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_cos_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_pow        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_pow_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_ln         False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_ln_chain   False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_exp        False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_exp_chain  False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sqrt       False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_sqrt_chain False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_const      False)) Or \
 \    (Repeat (Rewrite_Inst [(bdv,v_)] diff_var        False)) Or \
 \    (Repeat (Rewrite_Set             make_polynomial False)))) \
 \ (f_::real)"
 ));
